ConnectorClass [connectors.alauda.io/v1alpha1]

Description
ConnectorClass is the Schema for the connectorclasses API
Type
object

Specification

PropertyTypeDescription
apiVersionstring

APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

kindstring

Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

metadataObjectMeta

ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

specobject

Spec defines the desired state of ConnectorClass

statusobject

Status defines the actual state of ConnectorClass

.spec

Description
Spec defines the desired state of ConnectorClass
Type
object
PropertyTypeDescription
addressobject

Address indicates address param constraints for this ConnectorClass of connectors we only support string param type

apiobject

API defines connectorclass plugin api address and openapi specification api.ref can be address of plugin api, it should be a kubernetes svc api.uri can be an absolute URL(non-empty scheme and non-empty host) pointing to the target or a relative URI. Relative URIs will be resolved using the base URI retrieved from Ref. api.CACerts and api.audience is not implemented now

authobject

Auth indicates authentication constraints for this ConnectorClass of connectors

authProbesarray

AuthProbes defines authentication probe for this ConnectorClass of connectors

configurationsarray

Configurations defines connectorclass configuration

livenessProbeobject

LivenessProbe defines liveness probe for this ConnectorClass of connectors

paramsarray

Params indicates param constraints for this ConnectorClass of connectors we only support string param type

proxyobject

Proxy defines the proxy configuration for this ConnectorClass. Specifies how network traffic should be routed through a proxy server.

.spec.address

Description
Address indicates address param constraints for this ConnectorClass of connectors we only support string param type
Type
object
Required
name
PropertyTypeDescription
default

Default is the value a parameter takes if no input value is supplied.

descriptionstring

Description is a user-facing description of the parameter that may be used to populate a UI.

enumarray

Enum declares a set of allowed param input values. If Enum is not set, no input validation is performed for the param.

namestring

Name declares the name by which a parameter is referenced.

propertiesobject

Properties is the JSON Schema properties to support key-value pairs parameter.

typestring

Type is the user-specified type of the parameter. The possible types are currently "string", "array" and "object", and "string" is the default.

.spec.address.enum

Description
Enum declares a set of allowed param input values. If Enum is not set, no input validation is performed for the param.
Type
array

.spec.address.enum[]

Type
string

.spec.address.properties

Description
Properties is the JSON Schema properties to support key-value pairs parameter.
Type
object

.spec.api

Description
API defines connectorclass plugin api address and openapi specification `api.ref` can be address of plugin api, it should be a kubernetes svc `api.uri` can be an absolute URL(non-empty scheme and non-empty host) pointing to the target or a relative URI. Relative URIs will be resolved using the base URI retrieved from Ref. `api.CACerts` and `api.audience` is not implemented now
Type
object
PropertyTypeDescription
CACertsstring

CACerts are Certification Authority (CA) certificates in PEM format according to https://www.rfc-editor.org/rfc/rfc7468. If set, these CAs are appended to the set of CAs provided by the Addressable target, if any.

audiencestring

Audience is the OIDC audience. This need only be set, if the target is not an Addressable and thus the Audience can't be received from the Addressable itself. In case the Addressable specifies an Audience too, the Destinations Audience takes preference.

openapi

OpenAPI defines the openapi specification for the connectorclass api This OpenAPI specification can describe an API customized for the ConnectorClass, or it can describe the original tool's API exposed via the ConnectorClass's proxy. if client request path is not in the OpenAPI specification, it will just forward the request to proxy of the connectorclass.

permissionsobject

Permissions defines the request matching rules for different operations on the connectorclass api

refobject

Ref points to an Addressable.

uristring

URI can be an absolute URL(non-empty scheme and non-empty host) pointing to the target or a relative URI. Relative URIs will be resolved using the base URI retrieved from Ref.

.spec.api.permissions

Description
Permissions defines the request matching rules for different operations on the connectorclass api
Type
object
PropertyTypeDescription
regostring

Rego contains the Rego policy script that maps API requests to permission verbs. The script evaluates incoming requests and determines the required permission level.

Requirements:

  1. Must be defined under the 'permissions' package
  2. Must produce a 'result' object matching the PermissionMappingResult structure

Input Variables:

  • request.path (string): Request path
  • request.method (string): HTTP method (GET, POST, PUT, DELETE, etc.)
  • request.headers (map<string, list>): Request headers
  • request.query (map<string, list>): Request query parameters
  • request.body (dynamic): Parsed JSON body (available when Content-Type is application/json)

Output:

  • result.verb (string): Permission verb - "read", "write", "delete", or "" (default to http verb mapping)

Example: package permissions import future.keywords.if

result = { "verb": "read" } if { startswith(input.request.path, "/search") input.request.method == "POST" } else = { "verb": "" }

.spec.api.ref

Description
Ref points to an Addressable.
Type
object
Required
kindname
PropertyTypeDescription
addressstring

Address points to a specific Address Name.

apiVersionstring

API version of the referent.

groupstring

Group of the API, without the version of the group. This can be used as an alternative to the APIVersion, and then resolved using ResolveGroup. Note: This API is EXPERIMENTAL and might break anytime. For more details: https://github.com/knative/eventing/issues/5086

kindstring

Kind of the referent. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

namestring

Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

namespacestring

Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/ This is optional field, it gets defaulted to the object holding it if left out.

.spec.auth

Description
Auth indicates authentication constraints for this ConnectorClass of connectors
Type
object
PropertyTypeDescription
typesarray

Types represent the authentication types supported by connectors of the current connectorclass type When the array length is greater than 1, it means supporting multiple types, and the Connector can choose any one when using.

.spec.auth.types

Description
Types represent the authentication types supported by connectors of the current connectorclass type When the array length is greater than 1, it means supporting multiple types, and the Connector can choose any one when using.
Type
array

.spec.auth.types[]

Description
ConnectorClassAuthType represent the authentication types supported by connectors of the current connectorclass type
Type
object
Required
name
PropertyTypeDescription
descriptionstring

Description is the description of the AuthType

displayNamestring

DisplayName is the human readable name of the AuthType

generatorobject

Generator specifies how to generate authentication data dynamically. Can be used to implement custom authentication logic.

namestring

Name of the AuthType Must be unique within the ConnectorClass.

optionalboolean

Optional indicates whether the authentication information is optional for this ConnectorClass of connectors the default value is false

paramsarray

Params declares the data fields included in this authentication type. For known types, the definition of included params is optional. If not defined, the conventional params will be used.

secretTypestring

SecretType represents the secret type of the current authentication information follow k8s secret type definition. eg.kubernetes.io/basic-auth, kubernetes.io/ssh-auth, kubernetes.io/opaque

.spec.auth.types[].generator

Description
Generator specifies how to generate authentication data dynamically. Can be used to implement custom authentication logic.
Type
object
PropertyTypeDescription
regostring

Rego contains the Rego policy script that will be evaluated to generate authentication data. The script must define an 'auth' object that matches the following rules:

  1. Define its rules under the 'proxy' package
  2. Produce an 'auth' object containing AuthInjection structure.

.spec.auth.types[].params

Description
Params declares the data fields included in this authentication type. For known types, the definition of included params is optional. If not defined, the conventional params will be used.
Type
array

.spec.auth.types[].params[]

Description
ParamSpec defines arbitrary parameters needed beyond typed inputs (such as resources).
Type
object
Required
name
PropertyTypeDescription
default

Default is the value a parameter takes if no input value is supplied.

descriptionstring

Description is a user-facing description of the parameter that may be used to populate a UI.

enumarray

Enum declares a set of allowed param input values. If Enum is not set, no input validation is performed for the param.

namestring

Name declares the name by which a parameter is referenced.

propertiesobject

Properties is the JSON Schema properties to support key-value pairs parameter.

typestring

Type is the user-specified type of the parameter. The possible types are currently "string", "array" and "object", and "string" is the default.

.spec.auth.types[].params[].enum

Description
Enum declares a set of allowed param input values. If Enum is not set, no input validation is performed for the param.
Type
array

.spec.auth.types[].params[].enum[]

Type
string

.spec.auth.types[].params[].properties

Description
Properties is the JSON Schema properties to support key-value pairs parameter.
Type
object

.spec.authProbes

Description
AuthProbes defines authentication probe for this ConnectorClass of connectors
Type
array

.spec.authProbes[]

Description
ConnectorClassAuthProbe represents network the detection configuration
Type
object
Required
authName
PropertyTypeDescription
authNamestring

AuthName corresponds to spec.auth.types[].name, indicating the way to check for the corresponding authentication type

paramsarray

Params declares the data fields included in this probe it will use param value when probe

probeobject

Probe represents current detection configuration

.spec.authProbes[].params

Description
Params declares the data fields included in this probe it will use param value when probe
Type
array

.spec.authProbes[].params[]

Description
ParamSpec defines arbitrary parameters needed beyond typed inputs (such as resources).
Type
object
Required
name
PropertyTypeDescription
default

Default is the value a parameter takes if no input value is supplied.

descriptionstring

Description is a user-facing description of the parameter that may be used to populate a UI.

enumarray

Enum declares a set of allowed param input values. If Enum is not set, no input validation is performed for the param.

namestring

Name declares the name by which a parameter is referenced.

propertiesobject

Properties is the JSON Schema properties to support key-value pairs parameter.

typestring

Type is the user-specified type of the parameter. The possible types are currently "string", "array" and "object", and "string" is the default.

.spec.authProbes[].params[].enum

Description
Enum declares a set of allowed param input values. If Enum is not set, no input validation is performed for the param.
Type
array

.spec.authProbes[].params[].enum[]

Type
string

.spec.authProbes[].params[].properties

Description
Properties is the JSON Schema properties to support key-value pairs parameter.
Type
object

.spec.authProbes[].probe

Description
Probe represents current detection configuration
Type
object
PropertyTypeDescription
apiobject

API defines a network detection probe that uses the ConnectorClass API. The API endpoint for the probe is resolved from the ConnectorClass's spec.api configuration. If spec.api is not configured or is invalid, no API detection will be performed. The Path field within APIProbeAction specifies a relative path that is appended to the host of URI resolved from spec.api (e.g., spec.api.uri).

httpobject

Http represents the network detection using the http get method

.spec.authProbes[].probe.api

Description
API defines a network detection probe that uses the ConnectorClass API. The API endpoint for the probe is resolved from the ConnectorClass's `spec.api` configuration. If `spec.api` is not configured or is invalid, no API detection will be performed. The `Path` field within `APIProbeAction` specifies a relative path that is appended to the host of URI resolved from `spec.api` (e.g., `spec.api.uri`).
Type
object
PropertyTypeDescription
pathstring

Path represents the API address accessed during the current detection it is relative path, it will be appended to the host of URI resolved from spec.api (e.g., spec.api.uri) when execute the probe

.spec.authProbes[].probe.http

Description
Http represents the network detection using the http get method
Type
object
Required
path
PropertyTypeDescription
disableRedirectboolean

DisableRedirect indicates whether the probe should follow redirects, default is false

hoststring

Host represents the tool address for the current detection. usually, it would be empty, it will use the spec.address of connector

httpHeadersarray

Custom headers to set in the request. HTTP allows repeated headers.

methodstring

Method represents the HTTP method to use for the probe, support method: GET, POST. default is GET

pathstring

Path represents the API address accessed during the current detection it is relative path, it will be appended to the host of URI resolved from spec.address of connector when execute the probe

responseobject

Response defines the expected response validation rules. If not specified, the probe is considered successful if the request completes without error and returns a 2xx status code.

schemestring

Scheme to use for connecting to the host. If empty:

  • When Host is empty or matches the connector's address, the scheme from the connector's address is used.
  • Otherwise, defaults to http. If specified, this value will be used regardless of Host or connector's address.

.spec.authProbes[].probe.http.httpHeaders

Description
Custom headers to set in the request. HTTP allows repeated headers.
Type
array

.spec.authProbes[].probe.http.httpHeaders[]

Description
HTTPHeader describes a custom header to be used in HTTP probes
Type
object
Required
namevalue
PropertyTypeDescription
namestring

The header field name. This will be canonicalized upon output, so case-variant names will be understood as the same header.

valuestring

The header field value

.spec.authProbes[].probe.http.response

Description
Response defines the expected response validation rules. If not specified, the probe is considered successful if the request completes without error and returns a 2xx status code.
Type
object
PropertyTypeDescription
celstring

CEL contains a CEL (Common Expression Language) expression for response validation. The expression must evaluate to a boolean value. Available variables:

  • response.statusCode (int): HTTP status code
  • response.headers (map<string, list>): Response headers
  • response.body (dynamic): Parsed JSON body (if Content-Type is application/json and body is valid JSON)
  • response.bodyString (string): Response body as string

Example expressions:

  • response.statusCode == 200 && response.body.status == 'healthy'
  • response.body.uptime > 60 && response.body.errors.size() == 0
  • response.body.contains('success') && !response.body.contains('error')
  • response.headers['content-type'][0].startsWith('application/json')

CEL is recommended for simple to medium complexity validations:

  • Intuitive syntax similar to JavaScript/C/Python
  • Better performance for simple expressions
  • Native support in Kubernetes ecosystem
  • Lower learning curve

When both CEL and built-in rules (Contains, Regex, JSONPath) are specified, all rules must pass (AND logic).

.spec.configurations

Description
Configurations defines connectorclass configuration
Type
array

.spec.configurations[]

Description
ConnectorClassConfiguration defines connectorclass configuration
Type
object
PropertyTypeDescription
annotationsobject

Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/annotations

dataobject

Data contains the configuration data. Each key must consist of alphanumeric characters, '-', '_' or '.'.

namestring

Name of the configuration

.spec.configurations[].annotations

Description
Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/annotations
Type
object

.spec.configurations[].data

Description
Data contains the configuration data. Each key must consist of alphanumeric characters, '-', '_' or '.'.
Type
object

.spec.livenessProbe

Description
LivenessProbe defines liveness probe for this ConnectorClass of connectors
Type
object
PropertyTypeDescription
apiobject

API defines a network detection probe that uses the ConnectorClass API. The API endpoint for the probe is resolved from the ConnectorClass's spec.api configuration. If spec.api is not configured or is invalid, no API detection will be performed. The Path field within APIProbeAction specifies a relative path that is appended to the host of URI resolved from spec.api (e.g., spec.api.uri).

httpobject

Http represents the network detection using the http get method

.spec.livenessProbe.api

Description
API defines a network detection probe that uses the ConnectorClass API. The API endpoint for the probe is resolved from the ConnectorClass's `spec.api` configuration. If `spec.api` is not configured or is invalid, no API detection will be performed. The `Path` field within `APIProbeAction` specifies a relative path that is appended to the host of URI resolved from `spec.api` (e.g., `spec.api.uri`).
Type
object
PropertyTypeDescription
pathstring

Path represents the API address accessed during the current detection it is relative path, it will be appended to the host of URI resolved from spec.api (e.g., spec.api.uri) when execute the probe

.spec.livenessProbe.http

Description
Http represents the network detection using the http get method
Type
object
Required
path
PropertyTypeDescription
disableRedirectboolean

DisableRedirect indicates whether the probe should follow redirects, default is false

hoststring

Host represents the tool address for the current detection. usually, it would be empty, it will use the spec.address of connector

httpHeadersarray

Custom headers to set in the request. HTTP allows repeated headers.

methodstring

Method represents the HTTP method to use for the probe, support method: GET, POST. default is GET

pathstring

Path represents the API address accessed during the current detection it is relative path, it will be appended to the host of URI resolved from spec.address of connector when execute the probe

responseobject

Response defines the expected response validation rules. If not specified, the probe is considered successful if the request completes without error and returns a 2xx status code.

schemestring

Scheme to use for connecting to the host. If empty:

  • When Host is empty or matches the connector's address, the scheme from the connector's address is used.
  • Otherwise, defaults to http. If specified, this value will be used regardless of Host or connector's address.

.spec.livenessProbe.http.httpHeaders

Description
Custom headers to set in the request. HTTP allows repeated headers.
Type
array

.spec.livenessProbe.http.httpHeaders[]

Description
HTTPHeader describes a custom header to be used in HTTP probes
Type
object
Required
namevalue
PropertyTypeDescription
namestring

The header field name. This will be canonicalized upon output, so case-variant names will be understood as the same header.

valuestring

The header field value

.spec.livenessProbe.http.response

Description
Response defines the expected response validation rules. If not specified, the probe is considered successful if the request completes without error and returns a 2xx status code.
Type
object
PropertyTypeDescription
celstring

CEL contains a CEL (Common Expression Language) expression for response validation. The expression must evaluate to a boolean value. Available variables:

  • response.statusCode (int): HTTP status code
  • response.headers (map<string, list>): Response headers
  • response.body (dynamic): Parsed JSON body (if Content-Type is application/json and body is valid JSON)
  • response.bodyString (string): Response body as string

Example expressions:

  • response.statusCode == 200 && response.body.status == 'healthy'
  • response.body.uptime > 60 && response.body.errors.size() == 0
  • response.body.contains('success') && !response.body.contains('error')
  • response.headers['content-type'][0].startsWith('application/json')

CEL is recommended for simple to medium complexity validations:

  • Intuitive syntax similar to JavaScript/C/Python
  • Better performance for simple expressions
  • Native support in Kubernetes ecosystem
  • Lower learning curve

When both CEL and built-in rules (Contains, Regex, JSONPath) are specified, all rules must pass (AND logic).

.spec.params

Description
Params indicates param constraints for this ConnectorClass of connectors we only support string param type
Type
array

.spec.params[]

Description
ParamSpec defines arbitrary parameters needed beyond typed inputs (such as resources).
Type
object
Required
name
PropertyTypeDescription
default

Default is the value a parameter takes if no input value is supplied.

descriptionstring

Description is a user-facing description of the parameter that may be used to populate a UI.

enumarray

Enum declares a set of allowed param input values. If Enum is not set, no input validation is performed for the param.

namestring

Name declares the name by which a parameter is referenced.

propertiesobject

Properties is the JSON Schema properties to support key-value pairs parameter.

typestring

Type is the user-specified type of the parameter. The possible types are currently "string", "array" and "object", and "string" is the default.

.spec.params[].enum

Description
Enum declares a set of allowed param input values. If Enum is not set, no input validation is performed for the param.
Type
array

.spec.params[].enum[]

Type
string

.spec.params[].properties

Description
Properties is the JSON Schema properties to support key-value pairs parameter.
Type
object

.spec.proxy

Description
Proxy defines the proxy configuration for this ConnectorClass. Specifies how network traffic should be routed through a proxy server.
Type
object
PropertyTypeDescription
CACertsstring

CACerts are Certification Authority (CA) certificates in PEM format according to https://www.rfc-editor.org/rfc/rfc7468. If set, these CAs are appended to the set of CAs provided by the Addressable target, if any.

audiencestring

Audience is the OIDC audience. This need only be set, if the target is not an Addressable and thus the Audience can't be received from the Addressable itself. In case the Addressable specifies an Audience too, the Destinations Audience takes preference.

authExtractorobject

AuthExtractor specifies the method used to extract authentication data from incoming requests. The AuthExtractor is responsible for extracting the token required to perform proxy permission validation.

refobject

Ref points to an Addressable.

uristring

URI can be an absolute URL(non-empty scheme and non-empty host) pointing to the target or a relative URI. Relative URIs will be resolved using the base URI retrieved from Ref.

.spec.proxy.authExtractor

Description
AuthExtractor specifies the method used to extract authentication data from incoming requests. The AuthExtractor is responsible for extracting the token required to perform proxy permission validation.
Type
object
PropertyTypeDescription
regostring

Rego contains the Rego policy script that will be evaluated to extract proxy authentication data from the request. The script must define an 'auth' object that matches the following rules:

  1. Define its rules under the 'proxy' package
  2. Produce an 'auth' object has structure same as ProxyAuthExtractorResult. Example: package proxy auth = { "token": input.request.headers["Private-Token"][0] }

.spec.proxy.ref

Description
Ref points to an Addressable.
Type
object
Required
kindname
PropertyTypeDescription
addressstring

Address points to a specific Address Name.

apiVersionstring

API version of the referent.

groupstring

Group of the API, without the version of the group. This can be used as an alternative to the APIVersion, and then resolved using ResolveGroup. Note: This API is EXPERIMENTAL and might break anytime. For more details: https://github.com/knative/eventing/issues/5086

kindstring

Kind of the referent. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

namestring

Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

namespacestring

Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/ This is optional field, it gets defaulted to the object holding it if left out.

.status

Description
Status defines the actual state of ConnectorClass
Type
object
PropertyTypeDescription
annotationsobject

Annotations is additional Status fields for the Resource to save some additional State as well as convey more information to the user. This is roughly akin to Annotations on any k8s resource, just the reconciler conveying richer information outwards.

apiobject

API represents status of connectorclass api it will resolved based on spec.api if spec.api is empty or invalid, it will not be set if current field is empty, the connectorclass cannot provides any api service.

conditionsarray

Conditions the latest available observations of a resource's current state.

observedGenerationinteger

ObservedGeneration is the 'Generation' of the Service that was last processed by the controller.

proxyobject

Proxy represents status of connectorclass proxy it will resolved based on spec.proxy if spec.proxy is empty or invalid, it will not be set if current field is empty, the connectorclass cannot provides any proxy service.

.status.annotations

Description
Annotations is additional Status fields for the Resource to save some additional State as well as convey more information to the user. This is roughly akin to Annotations on any k8s resource, just the reconciler conveying richer information outwards.
Type
object

.status.api

Description
API represents status of connectorclass api it will resolved based on `spec.api` if `spec.api` is empty or invalid, it will not be set if current field is empty, the connectorclass cannot provides any api service.
Type
object
PropertyTypeDescription
addressobject

Address is a single Addressable address.

.status.api.address

Description
Address is a single Addressable address.
Type
object
PropertyTypeDescription
CACertsstring

CACerts is the Certification Authority (CA) certificates in PEM format according to https://www.rfc-editor.org/rfc/rfc7468.

audiencestring

Audience is the OIDC audience for this address.

namestring

Name is the name of the address.

urlstring

.status.conditions

Description
Conditions the latest available observations of a resource's current state.
Type
array

.status.conditions[]

Description
Condition defines a readiness condition for a Knative resource. See: https://github.com/kubernetes/community/blob/master/contributors/devel/sig-architecture/api-conventions.md#typical-status-properties
Type
object
Required
statustype
PropertyTypeDescription
lastTransitionTimestring

LastTransitionTime is the last time the condition transitioned from one status to another. We use VolatileTime in place of metav1.Time to exclude this from creating equality.Semantic differences (all other things held constant).

messagestring

A human readable message indicating details about the transition.

reasonstring

The reason for the condition's last transition.

severitystring

Severity with which to treat failures of this type of condition. When this is not specified, it defaults to Error.

statusstring

Status of the condition, one of True, False, Unknown.

typestring

Type of condition.

.status.proxy

Description
Proxy represents status of connectorclass proxy it will resolved based on `spec.proxy` if `spec.proxy` is empty or invalid, it will not be set if current field is empty, the connectorclass cannot provides any proxy service.
Type
object
PropertyTypeDescription
httpAddressobject

HttpAddress is a single Addressable address.

.status.proxy.httpAddress

Description
HttpAddress is a single Addressable address.
Type
object
PropertyTypeDescription
CACertsstring

CACerts is the Certification Authority (CA) certificates in PEM format according to https://www.rfc-editor.org/rfc/rfc7468.

audiencestring

Audience is the OIDC audience for this address.

namestring

Name is the name of the address.

urlstring

API Endpoints

The following API endpoints are available:

  • /apis/connectors.alauda.io/v1alpha1/namespaces/{namespace}/connectorclasses
    • DELETE: delete collection of ConnectorClass
    • GET: list objects of kind ConnectorClass
    • POST: create a new ConnectorClass
  • /apis/connectors.alauda.io/v1alpha1/namespaces/{namespace}/connectorclasses/{name}
    • DELETE: delete the specified ConnectorClass
    • GET: read the specified ConnectorClass
    • PATCH: partially update the specified ConnectorClass
    • PUT: replace the specified ConnectorClass
  • /apis/connectors.alauda.io/v1alpha1/namespaces/{namespace}/connectorclasses/{name}/status
    • GET: read status of the specified ConnectorClass
    • PATCH: partially update status of the specified ConnectorClass
    • PUT: replace status of the specified ConnectorClass

/apis/connectors.alauda.io/v1alpha1/namespaces/{namespace}/connectorclasses

HTTP method
DELETE
Description
delete collection of ConnectorClass
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
list objects of kind ConnectorClass
HTTP responses
HTTP codeResponse body
200 - OKConnectorClassList schema
401 - UnauthorizedEmpty
HTTP method
POST
Description
create a new ConnectorClass
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyConnectorClass schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKConnectorClass schema
201 - CreatedConnectorClass schema
202 - AcceptedConnectorClass schema
401 - UnauthorizedEmpty

/apis/connectors.alauda.io/v1alpha1/namespaces/{namespace}/connectorclasses/{name}

HTTP method
DELETE
Description
delete the specified ConnectorClass
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
202 - AcceptedStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
read the specified ConnectorClass
HTTP responses
HTTP codeResponse body
200 - OKConnectorClass schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update the specified ConnectorClass
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKConnectorClass schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace the specified ConnectorClass
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyConnectorClass schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKConnectorClass schema
201 - CreatedConnectorClass schema
401 - UnauthorizedEmpty

/apis/connectors.alauda.io/v1alpha1/namespaces/{namespace}/connectorclasses/{name}/status

HTTP method
GET
Description
read status of the specified ConnectorClass
HTTP responses
HTTP codeResponse body
200 - OKConnectorClass schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update status of the specified ConnectorClass
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKConnectorClass schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace status of the specified ConnectorClass
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyConnectorClass schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKConnectorClass schema
201 - CreatedConnectorClass schema
401 - UnauthorizedEmpty